var showtabs;
var selectedTab;
var interfaceTimerDelay;
var isScrollable;
var zoomMode;

// jQuery.noConflict();

jQuery("document").ready(function($) {

//    inittoolbar();

	zoomMode=options.defaultZoomSize;

	// display alt from PWG stuffs actions

	var stuffs_actions=$(".categoryActions",".stuffs_block .stuffs");
	
	if (stuffs_actions.length != 0) {
		stuffs_actions.each(function(index) {
			var images=$(this).find("img");
			if (images.length !=0) {
				images.each(function(index) {
					var alt_text = ($(this).attr("alt"));
					$(this).before(alt_text);
					$(this).parents("li").css("width","auto");
					$(this).remove();
				});
			}
		});
	}

	// gmaps icon
	
	var icon_gmaps=$("#icon_gmaps");
	var text_gmaps=$("#text_gmaps");
	if ((icon_gmaps.length == 1) && (text_gmaps.length ==1)) {
		icon_gmaps.text(text_gmaps.text());
		icon_gmaps.css("text-align","right");
	}
	
	// Tabs

	var delay;
	if (options.animatedTabs) {delay = "slow";} else {delay = 0;}
	
	var tab_titles=$(".tabTitle");
	var tab_blocks=$(".tabBlock");

	if ((tab_titles.length != 0) && (tab_titles.length == tab_blocks.length)) {
		tab_titles.each(function(index1) {
			var tab_title = $(this);
			tab_title.click(function () { 
				if ($(this).hasClass("tabSelected")) {
					$(this).removeClass("tabSelected");
					tab_blocks.each(function(index2) {
						if (index1 == index2) {
							$(this).hide(delay);
						} else {
							$(this).hide();
						}
					});
				} else {
					$(this).addClass("tabSelected");
					var old_selected_tab =-1;
					tab_titles.each(function(index2) {
						if ((index1 != index2) && ($(this).hasClass("tabSelected"))) {
						old_selected_tab=index2;
						$(this).removeClass("tabSelected");
						}
					});
					tab_blocks.each(function(index2) {
						if (index1 == index2) {
							if (old_selected_tab == -1) {
								$(this).show(delay);
							} else {
								$(this).show();
							}
						}
					});
					tab_blocks.each(function(index2) {
						if (index2 != index1) {
							$(this).hide();
						}
					});
				}
			});
		}); 
	}
	
	
	// Initialize navthumbs position
	Init_nav_thumbs();
  
	
	// Image autosize function inspired from Autosize Plugin (from cljosse)
	var img_W0=0;
	var img_H0=0;
	var img_ratio=0;

	if (options.imageAutosize) {
		// Autosize image
		$(window).resize(function () {
		
			var marge_inf_sup = options.imageAutosizeMargin;
			var Hmin = options.imageAutosizeMinHeight;
			
			var ImageContainer;
			
			if (options.imageAutosizeTitle) {
				ImageContainer = $("#theImgContainer");
			} else {
				ImageContainer = $("#theImage");
			}
			var Image = $("#theImage > img");

			var marge_inf = ImageContainer.height()-Image.height()+marge_inf_sup;
			if (Image.length == 0) return;
			var pos0 = $(Image).offset();
			if (!pos0) return;
			var img_top = parseInt(pos0.top);
			var win_height = $(window).height();
			var img_H = win_height - img_top - marge_inf;

			if (img_W0==0){
				img_W0=Image.width();
				img_H0=Image.height();
				img_ratio=img_W0/img_H0;
			}

			if (img_W0 == 0) return;

			if (img_H >= img_H0) img_H=img_H0;
			if (img_H <= Hmin) img_H=Hmin;

			var img_W = parseInt(img_H * img_ratio);
			Image.css("width", img_W + "px");
			Image.css("height", img_H+ "px");

			// limit img Container width

			var ImageBox=$("#theImgContainer");
			if (ImageBox.length != 0) {
				ImageBox.css("width",$("#theImage").outerWidth(true)+"px");
			}

			Calc_nav_thumbs_pos();
			
			return;

		});
		
		jQuery(window).resize();
	
	}	else {
		
		$(window).resize(function () {
			Calc_nav_thumbs_pos();
			return;
		});
	
	}
		
	Calc_nav_thumbs_pos()
  
});



function Init_nav_thumbs() {
	var tfade=options.navThumbsFade;

	var PrevBoxOut = $("#linkPrevOut");
	if (PrevBoxOut.length !=0)
	{
		var PrevBoxIn=$("#linkPrevIn");
		var PrevImgBox=$("#linkPrevIn > .navThumb");
		var PrevImg=$("#linkPrevIn > .navThumb > img");

		PrevBoxIn.mouseenter(function(){PrevImg.animate({opacity:1},tfade);});
		PrevBoxOut.mouseleave(function(){PrevImg.animate({opacity:0},tfade);});
	}

	var NextBoxOut = $("#linkNextOut");
	if (NextBoxOut.length !=0)
	{
		var NextBoxIn=$("#linkNextIn");
		var NextImgBox=$("#linkNextIn > .navThumb");
		var NextImg=$("#linkNextIn > .navThumb > img");

		NextBoxIn.mouseenter(function(){NextImg.animate({opacity:1},tfade);});
		NextBoxOut.mouseleave(function(){NextImg.animate({opacity:0},tfade);});
	}
}

function Calc_nav_thumbs_pos() {

	var Window = $(window);
	var Content = $("#content");
	var ImageBox = $("#theImage");
	var PrevImg=$("#linkPrevIn > .navThumb > img");

	var window_width = Window.width();
	var content_width = Content.width();
	var image_width = ImageBox.width();
	
	var PrevBoxOut = $("#linkPrevOut");
	if (PrevBoxOut.length !=0)
	{
		var PrevBoxIn=$("#linkPrevIn");
		var PrevImgBox=$("#linkPrevIn > .navThumb");
		var PrevImg=$("#linkPrevIn > .navThumb > img");

		// height

		var imgHeight = ImageBox.height();
		PrevBoxOut.css("height",imgHeight+"px");

		var prevImgTopMargin =  parseInt( (imgHeight - PrevImgBox.outerHeight()) / 2 );
		PrevImgBox.css("margin-top",prevImgTopMargin+"px");

		// position
		
		var prevbox_pos1= parseInt( ( content_width - image_width + PrevImg.outerWidth()) / 2 ) + 20;
		var prevbox_pos0= prevbox_pos1 - PrevBoxIn.outerWidth(true);
		var left_margin = parseInt( ( window_width - content_width ) / 2 );
		
		if (prevbox_pos0 + left_margin < 0 ) {
			prevbox_pos0 = - left_margin
			prevbox_pos1 = prevbox_pos0 + PrevBoxIn.outerWidth(true);
		}
		var prevbox_width = prevbox_pos1 - prevbox_pos0;
		
		PrevBoxOut.css("left",prevbox_pos0+"px");
		PrevBoxOut.css("width",prevbox_width+"px");
	}

	var NextBoxOut = $("#linkNextOut");
	if (NextBoxOut.length !=0)
	{
		var NextBoxIn=$("#linkNextIn");
		var NextImgBox=$("#linkNextIn > .navThumb");
		var NextImg=$("#linkNextIn > .navThumb > img");

		// height

		var imgHeight = ImageBox.height();
		NextBoxOut.css("height",imgHeight+"px");

		var nextImgTopMargin =  parseInt( (imgHeight - NextImg.outerHeight()) / 2 );
		NextImgBox.css("margin-top",nextImgTopMargin+"px");

		// position

		var nextbox_pos1= parseInt( ( content_width - image_width + NextImg.outerWidth()) / 2 ) + 20;
		var nextbox_pos0= nextbox_pos1 - NextBoxIn.outerWidth(true);
		var right_margin = parseInt( ( window_width - content_width ) / 2 );
		
		if (nextbox_pos0 + right_margin < 0 ) {
			nextbox_pos0 = - right_margin
			nextbox_pos1 = nextbox_pos0 + NextBoxIn.outerWidth(true);
		}
	
		var nextbox_width = nextbox_pos1 - nextbox_pos0;
		
		NextBoxOut.css("right",nextbox_pos0+"px");
		NextBoxOut.css("width",nextbox_width+"px");
	}
}


// Scripts taken from Gally Theme

function openDisplayHigh(url)
{
  $('#theImageHigh').css(
    {
      width:$("html").get(0).scrollWidth+"px",
      height:$("html").get(0).scrollHeight+"px",
      display:"block"
    }
  );

  if($("#theImgHigh").attr('src')=="")
  {
    p = new Object();
    p.left = (($(window).width()-$("#theImgHighContainer").attr("clientWidth")-options.paddingContainer*2)/2)+"px";
    p.top = (($(window).height()-$("#theImgHighContainer").attr("clientHeight")-options.paddingContainer*2)/2)+"px";


    $('#theImgHighContainer')
      .css(
        {
          left:p.left,
          top:p.top,
          padding:options.paddingContainer+"px"
        }
      );


    $("#theImgHigh")
      .load(
        function ()
        {
          $(document).data("highWidth", $("#theImgHigh").width());
          $(document).data("highHeight", $("#theImgHigh").height());

          p=calcImgHighPositionAndSize(zoomMode);

          $('#theImgHighContainer').css("background-image", "none")
          displayZoomHigh();
          $("#theImgHigh").css( {display:"block"} );
        }
      )
      .attr('src', url);

    if(options.highResClickMode=='close')
    {
      $("#theImgHigh").bind('click', closeDisplayHigh);
    }
    else
    {
      // switch zoom
      $("#theImgHigh").bind('click', switchZoomHigh);
    }
  }
  else
  {
    p=calcImgHighPositionAndSize(zoomMode);

    $('#theImgHighContainer')
      .css(
        {
          left:p.left+"px",
          top:p.top+"px",
          width:p.width+"px",
          height:p.height+"px"
        }
      );
  }
}

function calcImgHighPositionAndSize(zoom)
{
  p = new Object();

  if(zoom=='full')
  {
    p.width = ($("html").get(0).clientWidth-(options.marginContainer+options.paddingContainer)*2);
    p.height = ($("html").get(0).clientHeight-(options.marginContainer+options.paddingContainer)*2);
    p.left=options.marginContainer;
    p.top=options.marginContainer;

    if(p.width>$(document).data("highWidth"))
    {
      p.width = $(document).data("highWidth")-options.paddingContainer*2;
      p.left = ($("html").get(0).clientWidth-p.width)/2;
    }

    if(p.height>$(document).data("highHeight"))
    {
      p.height = $(document).data("highHeight")-options.paddingContainer*2;
      p.top = ($("html").get(0).clientHeight-p.height)/2;
    }
  }
  else
  {
    //zoom = 'fit'
    ratioImg = $(document).data("highWidth") / $(document).data("highHeight");
    ratioPage = $("html").get(0).clientWidth / $("html").get(0).clientHeight;

    if((ratioPage > 1 && (ratioPage > ratioImg)) ||
       (ratioPage < 1 && (ratioPage < ratioImg)))
    {
      p.height = ($("html").get(0).clientHeight-(options.marginContainer+options.paddingContainer)*2);
      p.width = p.height*ratioImg;
    }
    else
    {
      p.width = ($("html").get(0).clientWidth-(options.marginContainer+options.paddingContainer)*2);
      p.height = p.width/ratioImg;
    }
    p.left = ($("html").get(0).clientWidth-p.width)/2;
    p.top = ($("html").get(0).clientHeight-p.height)/2;
  }

  return(p);
}

function closeDisplayHigh()
{
  $('#theImageHigh').css('display', 'none');
}

function switchZoomHigh()
{
  if(zoomMode=='full')
  {
    zoomMode="fit";
  }
  else
  {
    zoomMode="full";
  }

  $("#theImgHighZoomButton").toggleClass('full').toggleClass('fit');

  displayZoomHigh();
}

function displayZoomHigh()
{
  p=calcImgHighPositionAndSize(zoomMode);

  $('#theImgHighContainer').css(
      {
        left:p.left+"px",
        top:p.top+"px",
        width:p.width+"px",
        height:p.height+"px"
      }
    );

    if(zoomMode=="full")
    {
      $("#theImgHigh")
        .css(
          {
            width:$(document).data("highWidth")+"px",
            height:$(document).data("highHeight")+"px"
          }
        );
      $('#theImgHighContainer').bind("mousemove",
          function(event)
          {
            deadArea = options.marginContainer*2;
            mouseX=Math.max(Math.min(event.clientX-this.offsetLeft, this.clientWidth - deadArea), deadArea);
            mouseY=Math.max(Math.min(event.clientY-this.offsetTop, this.clientHeight - deadArea), deadArea);
            $("#theImgHigh")
              .css("left",Math.round(($("#theImgHigh").attr("scrollWidth")-this.clientWidth) * -(mouseX-deadArea)/(this.clientWidth-2*deadArea))+"px")
              .css("top",Math.round(($("#theImgHigh").attr("scrollHeight")-this.clientHeight) * -(mouseY-deadArea)/(this.clientHeight-2*deadArea))+"px");
          }
        );
    }
    else
    {
      $("#theImgHigh")
        .css(
          {
            width:p.width+"px",
            height:p.height+"px",
            left:"0px",
            top:"0px"
          }
        );
      $('#theImgHighContainer').unbind("mousemove");
    }
}




